#include "cmain.h"

CMain cMain;

//-Конструктор класса--------------------------------------------------------
CMain::CMain()
{
 //создаём директорию
 mkdir("./image",S_IRWXU|S_IRGRP|S_IXGRP|S_IROTH |S_IXOTH); 
 ColorImage=new unsigned char[COLOR_IMAGE_SIZE];
 VPtr=new unsigned char[COLOR_IMAGE_SIZE*4]; 
 memset(VPtr,COLOR_IMAGE_SIZE*4,0);
 SaveAllFrame=false;
 LastSavedFrameIndex=0;
 //запускаем поток управления устройством
 cReceiveThread.StartThread(); 
}
//-Деструктор класса---------------------------------------------------------
CMain::~CMain()
{  
 if (VPtr!=NULL) delete[](VPtr);
 VPtr=NULL;	
 if (ColorImage!=NULL) delete[](ColorImage);
 ColorImage=NULL;	
 //останавливаем поток управления устройством
 cReceiveThread.StopThread();  
}
//-Замещённые функции предка-----------------------------------------------
//-Новые функции класса------------------------------------------------------

//----------------------------------------------------------------------------------------------------
//открытие окна
//----------------------------------------------------------------------------------------------------
bool CMain::OnOpening(void)
{
 return(true);
}
//----------------------------------------------------------------------------------------------------
//закрытие окна
//----------------------------------------------------------------------------------------------------
bool CMain::OnClosing(void)
{
 return(true);	
}
//----------------------------------------------------------------------------------------------------
//перерисовать картинку
//----------------------------------------------------------------------------------------------------
void CMain::Redraw(void)
{
 //формируем изображение	
 unsigned long *s_img=reinterpret_cast<unsigned long*>(ColorImage);
 unsigned long *d_img=reinterpret_cast<unsigned long*>(VPtr);
 for(long y=0;y<IMAGE_HEIGHT*2;y++)
 { 	
  for(long x=0;x<IMAGE_WIDTH*2;x++)
  {  	
   unsigned long color=*(s_img+(x/2)+(y/2)*IMAGE_WIDTH);
   *d_img=color; 
   d_img++;
  }
 }	
 PhDim_t ImageSize;
 ImageSize.w=IMAGE_WIDTH*2;
 ImageSize.h=IMAGE_HEIGHT*2;
 int ImageBPL=ImageSize.w*4;
 PhPoint_t pos;
 pos.x=5;
 pos.y=5;
 PgDrawImage(VPtr,Pg_IMAGE_DIRECT_8888,&pos,&ImageSize,ImageBPL,0);
}
//----------------------------------------------------------------------------------------------------
//обработка таймера
//----------------------------------------------------------------------------------------------------
void CMain::OnTimer(void)
{
 //получаем раскрашенное изображение
 unsigned long index;
 cReceiveThread.CopyColorImage(ColorImage,COLOR_IMAGE_SIZE,index);
 //сохраняем изображение 
 if (SaveAllFrame==true)//требуется сохранить изображение
 {
  PtSetResource(ABW_PtButton_SaveAllFrame,Pt_ARG_FILL_COLOR,Pg_GREEN,0);
  if (LastSavedFrameIndex!=index) SaveColorImage();//изображение сменилось и его нужно сохранить
 } 
 else PtSetResource(ABW_PtButton_SaveAllFrame,Pt_ARG_FILL_COLOR,Pg_GRAY,0);
 LastSavedFrameIndex=index;
 Redraw();	
}
//-Функции обработки сообщений класса----------------------------------------

//----------------------------------------------------------------------------------------------------
//сохранять все кадры
//----------------------------------------------------------------------------------------------------
void CMain::OnButton_SaveAllFrame(void)
{
 if (SaveAllFrame==false) SaveAllFrame=true;
                     else SaveAllFrame=false;	 
}
//----------------------------------------------------------------------------------------------------
//сохранить текущий кадр
//----------------------------------------------------------------------------------------------------
void CMain::OnButton_SaveCurrentFrame(void)
{
 SaveColorImage();	
}

//-Новые функции класса------------------------------------------------------

//----------------------------------------------------------------------------------------------------
//сохранить раскрашенное изображение
//----------------------------------------------------------------------------------------------------
void CMain::SaveColorImage(void)
{
 //считываем дату и время
 time_t time_main=time(NULL);
 tm *tm_main=localtime(&time_main);
 //ищем свободный файл
 char filename[1024];
 for(long index=1;index<1000;index++)	
 {
  sprintf(filename,"./image/img[%04i.%02i.%02i %02i_%02i_%02i-%03ld].tga",tm_main->tm_year+1900,tm_main->tm_mon+1,tm_main->tm_mday,tm_main->tm_hour,tm_main->tm_min,tm_main->tm_sec,index);
  FILE *file=fopen(filename,"rb");
  if (file==NULL)//такого файла ещё нет
  {
   SaveTGA(filename,IMAGE_WIDTH,IMAGE_HEIGHT,ColorImage);    	     
   break;
  }
  else fclose(file);     
 }	
}
//----------------------------------------------------------------------------------------------------
//сохранить тепловое изображение
//----------------------------------------------------------------------------------------------------
void CMain::SaveThermalImage(void)
{
	
}


//-Прочее--------------------------------------------------------------------

